Leetcode 568. Maximum Vacation Days

Problem:

LeetCode wants to give one of its best employees the option to travel among N cities to collect algorithm problems. But all work and no play makes Jack a dull boy, you could take vacations in some particular cities and weeks. Your job is to schedule the traveling to maximize the number of vacation days you could take, but there are certain rules and restrictions you need to follow.

Rules and restrictions:

  1. You can only travel among N cities, represented by indexes from 0 to N-1. Initially, you are in the city indexed 0 on Monday.
  2. The cities are connected by flights. The flights are represented as a N*N matrix (not necessary symmetrical), called flights representing the airline status from the city i to the city j. If there is no flight from the city i to the city j, flights[i][j] = 0; Otherwise, flights[i][j] = 1. Also, flights[i][i] = 0 for all i.
  3. You totally have K weeks (each week has 7 days) to travel. You can only take flights at most once per day and can only take flights on each week's Monday morning. Since flight time is so short, we don't consider the impact of flight time.
  4. For each city, you can only have restricted vacation days in different weeks, given an N*K matrix called days representing this relationship. For the value of days[i][j], it represents the maximum days you could take vacation in the city i in the week j.

You're given the flights matrix and days matrix, and you need to output the maximum vacation days you could take during K weeks.

Example 1:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[1,3,1],[6,0,3],[3,3,3]]
Output: 12
Explanation: 
Ans = 6 + 3 + 3 = 12.
One of the best strategies is: 1st week : fly from city 0 to city 1 on Monday, and play 6 days and work 1 day.
(Although you start at city 0, we could also fly to and start at other cities since it is Monday.) 2nd week : fly from city 1 to city 2 on Monday, and play 3 days and work 4 days. 3rd week : stay at city 2, and play 3 days and work 4 days.

Example 2:

Input:flights = [[0,0,0],[0,0,0],[0,0,0]], days = [[1,1,1],[7,7,7],[7,7,7]]
Output: 3
Explanation: 
Ans = 1 + 1 + 1 = 3.
Since there is no flights enable you to move to another city, you have to stay at city 0 for the whole 3 weeks.
For each week, you only have one day to play and six days to work.
So the maximum number of vacation days is 3.

Example 3:

Input:flights = [[0,1,1],[1,0,1],[1,1,0]], days = [[7,0,0],[0,7,0],[0,0,7]]
Output: 21
Explanation:
Ans = 7 + 7 + 7 = 21
One of the best strategies is: 1st week : stay at city 0, and play 7 days. 2nd week : fly from city 0 to city 1 on Monday, and play 7 days. 3rd week : fly from city 1 to city 2 on Monday, and play 7 days.

Note:

  1. N and K are positive integers, which are in the range of [1, 100].
  2. In the matrix flights, all the values are integers in the range of [0, 1].
  3. In the matrix days, all the values are integers in the range [0, 7].
  4. You could stay at a city beyond the number of vacation days, but you should work on the extra days, which won't be counted as vacation days.
  5. If you fly from the city A to the city B and take the vacation on that day, the deduction towards vacation days will count towards the vacation days of city B in that week.
  6. We don't consider the impact of flight hours towards the calculation of vacation days.
Solution:

  题目很长,但难度也就是Hard中的easy题。直接想到动态规划,dp[i][j]用于存储第i周在j城的最多休息日(i和j都从0开始),flights[i][j]表示是否能从i城飞到j城(原flights要把对角线上的元素设置为1,我也不明白题目为什么要把对角线元素设置为0,毕竟从自己所在位置飞到自己位置逻辑上也说的通),如果dp[i][j]为-1,则说明不存在路径能飞到j城,因此跳过计算。现在就很简单了,对于dp[i][j],在dp[i-1][t]中寻找一座城t,t是0到N任意一座城,使得flights[t][j]为1(表明能从t飞到j城)且dp[i-1][t]不为-1(表明有路径从0飞到t城),计算最大的节假日时间。时间复杂度为O(K*N2)。

Code:

 

 1 class Solution {
 2 public:
 3     int maxVacationDays(vector<vector<int>>& flights, vector<vector<int>>& days) {
 4         int N = days.size();
 5         int K = days[0].size();
 6         for(int i = 0;i != N;++i)
 7             flights[i][i] = 1;
 8         vector<vector<int>> dp(K,vector<int>(N,-1));
 9         for(int j = 0;j != N;++j){
10             if(flights[0][j] == 1)
11                 dp[0][j] = days[j][0];
12         }
13         for(int i = 1;i != K;++i){
14             for(int j = 0;j != N;++j){
15                 for(int t = 0;t != N;++t){
16                     if(flights[t][j] == 1 && dp[i-1][t] != -1){
17                         dp[i][j] = max(dp[i][j],dp[i-1][t]+days[j][i]);
18                     }
19                 }
20             }
21         }
22         int result = 0;
23         for(int j = 0;j != N;++j)
24             result = max(result,dp[K-1][j]);
25         return result;
26     }
27 };

 

posted on 2019-01-08 12:19  周浩炜  阅读(286)  评论(0编辑  收藏  举报

导航